# Exemplo-1 - Adaptado de ns/tcl/ex/simple.tcl (exemplo do ns)
set ns [new Simulator]

# arquivos de trace 
set f [open out.tr w]
set nf [open out.nam w]

$ns trace-all $f
$ns namtrace-all $nf

# criacao de alguns ns
set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]

# Criacao de alguns agentes
set udp0  [new Agent/UDP] 
set null0 [new Agent/Null] 
set tcp   [new Agent/TCP]
set sink  [new Agent/TCPSink]

# Criacao de algumas aplicacoes 
set cbr0  [new Application/Traffic/CBR]
set ftp   [new Application/FTP]

# Criacao de enlaces
$ns duplex-link $n0 $n2 5Mb 2ms DropTail
$ns duplex-link $n1 $n2 5Mb 2ms DropTail
$ns duplex-link $n2 $n3 1.5Mb 10ms DropTail

# anexando agentes
$cbr0 attach-agent $udp0
$ns attach-agent $n0 $udp0 
$ns attach-agent $n3 $null0 
$ns connect $udp0 $null0

$ftp attach-agent $tcp
$ns attach-agent $n1 $tcp
$ns attach-agent $n3 $sink
$ns connect $tcp $sink

# Imprimindo algumas variveis na sada
puts [$cbr0 set packet_size_]
puts [$cbr0 set rate_]

# escalonando algumas tarefas
$ns at 0.1 "$cbr0 start"
$ns at 0.5 "$ftp start"
$ns at 1.35 "$ns detach-agent $n1 $tcp ; $ns detach-agent $n3 $sink"
$ns at 3.0 "finaliza"

proc finaliza {} {
        global ns f nf
        $ns flush-trace
        close $f
        close $nf
        puts "Executando o nam..."
        exec nam out.nam &
        exit 0
}

# Finalmente, inicia a simulao
$ns run
