# Exemplo-2 - Adaptado de example2.tcl (Tutorial de Marc Greis)
set ns [new Simulator]

# Define cores para os fluxos de dados
$ns color 1 Blue ; $ns color 2 Red

# Abre arquivos de trace para o nam
set nf [open out.nam w]
$ns namtrace-all $nf

proc finish {} {
        global ns nf
        $ns flush-trace
	     close $nf
        exec nam out.nam &
        exit 0
}

# Cria quatro ns
set n0 [$ns node] ; set n1 [$ns node] ; set n2 [$ns node] ; set n3 [$ns node]

# Cria enlaces
$ns duplex-link $n0 $n2 1Mb 10ms DropTail
$ns duplex-link $n1 $n2 1Mb 10ms DropTail
$ns duplex-link $n3 $n2 1Mb 10ms DropTail
#$ns duplex-link $n3 $n2 1Mb 10ms SFQ

$ns duplex-link-op $n0 $n2 orient right-down
$ns duplex-link-op $n1 $n2 orient right-up
$ns duplex-link-op $n2 $n3 orient right

# Monitora a fila no enlace n2-n3
$ns duplex-link-op $n2 $n3 queuePos 0.45

# Cria agentes CBR e anexa aos ns
set cbr0 [new Application/Traffic/CBR]
set cbr1 [new Application/Traffic/CBR]
set udp0 [new Agent/UDP]
set udp1 [new Agent/UDP]
set null0 [new Agent/Null]
set null1 [new Agent/Null]
$cbr0 attach-agent $udp0
$cbr1 attach-agent $udp1
$ns attach-agent $n0 $udp0
$ns attach-agent $n1 $udp1
$ns attach-agent $n3 $null0
$ns attach-agent $n3 $null1
$ns connect $udp0 $null0
$ns connect $udp1 $null1

$cbr0 set packetSize_ 512
$cbr0 set interval_ 0.005
$cbr1 set packetSize_ 512
$cbr1 set interval_ 0.005

$udp0 set fid_ 1
$udp1 set fid_ 2

# Escalona eventos para os agents CBR
$ns at 0.1 "$cbr0 start" ; $ns at 0.5 "$cbr1 start"
$ns at 1.0 "$cbr1 stop"  ; $ns at 1.5 "$cbr0 stop"
$ns at 2.0 "finish"

# Inicia a simulao
$ns run
