# Exemplo-3 - Controle de congestionamento no TCP
set ns [new Simulator]		;# Cria o objeto "simulador"

set nf [open out.nam w] 	;# Abre o arquivo de trace do nam
$ns namtrace-all $nf

proc finish {} {			;# Define procedimento a ser executado no final
        global ns nf
        $ns flush-trace
        close $nf
        exec nam out.nam &
        exit 0
}

set n0 [$ns node] ; set n1 [$ns node] 	; #Cria 4 ns
set n2 [$ns node] ; set n3 [$ns node]

$ns duplex-link $n0 $n2 1Mb 10ms DropTail	;# Cria links entre os ns
$ns duplex-link $n1 $n2 1Mb 10ms DropTail
$ns duplex-link $n2 $n3 1Mb 10ms DropTail
#$ns duplex-link $n2 $n3 1Mb 100ms DropTail

$ns queue-limit $n2 $n3 10		;# Limita fila no enlace 2-3 (10 pacotes)
$ns duplex-link-op $n2 $n3 queuePos 0.5	;# monitora a fila do enlace 2-3

# Orientaoes para o nam
$ns duplex-link-op $n1 $n2 orient up
$ns duplex-link-op $n0 $n2 orient right
$ns duplex-link-op $n2 $n3 orient right
Agent/TCP set nam_tracevar_ true		;# Habilita "trace" de variveis TCP (nam)

set tcp0 [new Agent/TCP]		;# Cria agente TCP
#set tcp1 [new Agent/TCP/Newreno]	;# Cria agente TCP
$ns attach-agent $n0 $tcp0		;# Anexa agente tcp0 ao n 0
$tcp0 set packet_size_ 1500		;# Tamanho mximo de pacote em bytes
set sink0 [new Agent/TCPSink]		;# Cria agente TCP consumidor
$ns attach-agent $n3 $sink0		;# Anexa agente sink0 ao n 3
$ns connect $tcp0 $sink0 		;# Connect TCP source with TCP sink
set ftp0 [$tcp0 attach-source FTP]	;# Cria aplicacao FTP e anexa-a ao agente tcp0

set tcp1 [new Agent/TCP]		;# Cria agente TCP
#set tcp1 [new Agent/TCP/Newreno]	;# Cria agente TCP
$ns attach-agent $n1 $tcp1		;# Anexa agente tcp1 ao n 1
$tcp1 set packet_size_ 1500		;# Tamanho mximo de pacote em bytes
set sink1 [new Agent/TCPSink]		;# Cria agente TCP consumidor
$ns attach-agent $n3 $sink1		;# Anexa agente sink1 ao n 3
$ns connect $tcp1 $sink1		;# Connect TCP source with TCP sink
set ftp1 [$tcp1 attach-source FTP]	;# Cria aplicacao FTP e anexa-a ao agente tcp1

# Define cores para os fluxos de dados tcp0=azul, tcp1=vermelho
$ns color 1 Blue ; $ns color 2 Red
$tcp0 set fid_ 1 ; $tcp1 set fid_ 2

# Adiciona o rastreamento de variveis
$ns add-agent-trace $tcp0 tcp0	;# label "tcp0"
$ns add-agent-trace $tcp1 tcp1	;# label "tcp1"
$ns monitor-agent-trace $tcp0		;# Caixinha nam para monitorar variveis do tcp0
$ns monitor-agent-trace $tcp1		;# Caixinha nam para monitorar variveis do tcp1
$tcp0 tracevar cwnd_			;# rastreia a varivel cwnd_ do tcp0
$tcp1 tracevar cwnd_			;# rastreia a varivel cwnd_ do tcp1
#$tcp0 tracevar ssthresh_
#$tcp1 tracevar ssthresh_
#$tcp0 tracevar rtt_
#$tcp1 tracevar rtt_

# Programa os eventos da simulao
$ns at 0.1 "$ftp0 start"
$ns at 1.0 "$ftp1 start"
$ns at 14.0 "$ftp1 stop"
$ns at 14.5 "$ftp0 stop"
$ns at 25.0 "finish"

# Executa a simulao
$ns run

