# Exemplo-3 - Controle de congestionamento no TCP
set ns [new Simulator]		;# Cria o objeto "simulador"

set nf [open out.nam w] 	;# Abre o arquivo de trace do nam
#$ns namtrace-all $nf

#Open the output files
set f0 [open jai3-0.tr w]
set f1 [open jai3-1.tr w]

proc finish {} {			;# Define procedimento a ser executado no final
        global ns nf f0 f1
        $ns flush-trace
        close $nf
 	close $f0
	close $f1

       #exec nam out.nam &

	#Call xgraph to display the results
	exec xgraph jai3-0.tr jai3-1.tr -geometry 700x500 &

	exit 0
}

proc record {} {
        global sink0 sink1 f0 f1

	#Get an instance of the simulator
	set ns [Simulator instance]
	#Set the time after which the procedure should be called again
        set time 0.3
	#How many bytes have been received by the traffic sinks?
        set bw0 [$sink0 set bytes_]
        set bw1 [$sink1 set bytes_]
	#Get the current time
        set now [$ns now]
	#Calculate the bandwidth (in MBit/s) and write it to the files
        puts $f0 "$now [expr $bw0/$time*8/1000]"
        puts $f1 "$now [expr $bw1/$time*8/1000]"
	#Reset the bytes_ values on the traffic sinks
        $sink0 set bytes_ 0
        $sink1 set bytes_ 0
	#Re-schedule the procedure
        $ns at [expr $now+$time] "record"
}


set n0 [$ns node] ; set n1 [$ns node] 	; #Cria 4 ns
set n2 [$ns node] ; set n3 [$ns node]

$ns duplex-link $n0 $n2 1Mb 10ms DropTail	;# Cria links entre os ns
$ns duplex-link $n1 $n2 1Mb 10ms DropTail
$ns duplex-link $n2 $n3 1Mb 10ms DropTail
#$ns duplex-link $n2 $n3 1Mb 100ms DropTail

$ns queue-limit $n2 $n3 10		;# Limita fila no enlace 2-3 (10 pacotes)
$ns duplex-link-op $n2 $n3 queuePos 0.5	;# monitora a fila do enlace 2-3

# Orientaoes para o nam
$ns duplex-link-op $n1 $n2 orient up
$ns duplex-link-op $n0 $n2 orient right
$ns duplex-link-op $n2 $n3 orient right
Agent/TCP set nam_tracevar_ true		;# Habilita "trace" de variveis TCP (nam)

#set tcp0 [new Agent/TCP]		;# Cria agente TCP
set tcp0 [new Agent/TCP/Newreno]	;# Cria agente TCP
$ns attach-agent $n0 $tcp0		;# Anexa agente tcp0 ao n 0
$tcp0 set packet_size_ 1500		;# Tamanho mximo de pacote em bytes
set sink0 [new Agent/TCPSink]		;# Cria agente TCP consumidor
$ns attach-agent $n3 $sink0		;# Anexa agente sink0 ao n 3
$ns connect $tcp0 $sink0 		;# Connect TCP source with TCP sink
set ftp0 [$tcp0 attach-source FTP]	;# Cria aplicacao FTP e anexa-a ao agente tcp0

#set tcp1 [new Agent/TCP]		;# Cria agente TCP
set tcp1 [new Agent/TCP/Newreno]	;# Cria agente TCP
$ns attach-agent $n1 $tcp1		;# Anexa agente tcp1 ao n 1
$tcp1 set packet_size_ 1500		;# Tamanho mximo de pacote em bytes
set sink1 [new Agent/TCPSink]		;# Cria agente TCP consumidor
$ns attach-agent $n3 $sink1		;# Anexa agente sink1 ao n 3
$ns connect $tcp1 $sink1		;# Connect TCP source with TCP sink
set ftp1 [$tcp1 attach-source FTP]	;# Cria aplicacao FTP e anexa-a ao agente tcp1

# Define cores para os fluxos de dados tcp0=azul, tcp1=vermelho
$ns color 1 Blue ; $ns color 2 Red
$tcp0 set fid_ 1 ; $tcp1 set fid_ 2

# Adiciona o rastreamento de variveis
$ns add-agent-trace $tcp0 tcp0	;# label "tcp0"
$ns add-agent-trace $tcp1 tcp1	;# label "tcp1"
$ns monitor-agent-trace $tcp0		;# Caixinha nam para monitorar variveis do tcp0
$ns monitor-agent-trace $tcp1		;# Caixinha nam para monitorar variveis do tcp1
$tcp0 tracevar cwnd_			;# rastreia a varivel cwnd_ do tcp0
$tcp1 tracevar cwnd_			;# rastreia a varivel cwnd_ do tcp1
$tcp0 tracevar ssthresh_
$tcp1 tracevar ssthresh_
$tcp0 tracevar rtt_
$tcp1 tracevar rtt_

# Programa os eventos da simulao
$ns at 0.0 "record"

$ns at 0.1 "$ftp0 start"
$ns at 0.5 "$ftp1 start"
$ns at 49.0 "$ftp1 stop"
$ns at 50 "$ftp0 stop"
$ns at 51.0 "finish"

# Executa a simulao
$ns run

